#include "Stack.h"

DStack::DStack(int depth)
{
  m_depth = depth;
  m_top = -1;
  m_data = new double[m_depth];
}

DStack::~DStack()
{
  delete [] m_data;
}

double DStack::top() const {
  if (m_top >= 0) {
    return m_data[m_top];
  }
  else {
    throw StackUnderflow();
  }
}

double DStack::pop() {
  if (m_top >= 0) {
    return m_data[m_top--];
  }
  else {
    throw StackUnderflow();
  }
}

void DStack::push(double value) {
  if (m_top < m_depth - 1) {
    m_data[++m_top] = value;
  }
  else {
    throw StackOverflow();
  }
}

void DStack::reset() {
  m_top = -1;
}

